﻿Imports System.Data.SqlClient
Imports CercaFeina.business


Public Class CercarFeinaBD
    Private Const ConnectionString = "Data Source=SERVERCONCHI;Initial Catalog=CercaFeinaBD;Integrated Security=True"

    Public Function executarConsultaDS(ByVal strSql As String) As DataSet
        Dim RsDS As New DataSet
        Dim Rs As New SqlCommand
        Dim da As New SqlDataAdapter
        Dim con As New SqlConnection

        Try
            ' Recupero la cadena de connexió a la BBDD
            con.ConnectionString = ConnectionString
            ' Assigno la consulta a l'objecte Command
            Rs.CommandText = strSql
            ' Estableixo el temps màxim de recuperació de la consulta avanç de donar error
            Rs.CommandTimeout = 300
            ' Estableixo el tipos de consulta
            Rs.CommandType = CommandType.Text
            ' Assigno i obro la connexió
            Rs.Connection = con
            Rs.Connection.Open()

            ' Retorno el resultat en forma de DataSet
            da.SelectCommand = Rs
            da.Fill(RsDS)

            Return RsDS

        Catch ex As Exception
            Return Nothing
        Finally
            ' Llibero el recurs command
            Rs.Dispose()
            Rs = Nothing
            ' Llibero el DataSet
            RsDS.Dispose()
            RsDS = Nothing
            ' Llibero el dataadapter
            da.Dispose()
            da = Nothing

            ' Tancon la connexió i la llibero
            If con.State = ConnectionState.Open Then con.Close()
            con = Nothing
        End Try

    End Function
    Public Function executarConsultaDR(ByVal strSql As String) As SqlDataReader
        Dim RsDR As SqlDataReader = Nothing
        Dim Rs As New SqlCommand
        Dim con As New SqlConnection

        Try
            ' Recupero la cadena de connexió a la BBDD
            con.ConnectionString = ConnectionString
            ' Assigno la consulta a l'objecte Command
            Rs.CommandText = strSql
            ' Estableixo el temps màxim de recuperació de la consulta avanç de donar error
            Rs.CommandTimeout = 300
            ' Estableixo el tipos de consulta
            Rs.CommandType = CommandType.Text
            ' Assigno i obro la connexió
            Rs.Connection = con
            Rs.Connection.Open()

            ' Retorno el resultat en forma de DataReader
            RsDR = Rs.ExecuteReader()
            ' llibero el recurs command
            Rs.Dispose()
            Rs = Nothing

            Return RsDR
        Catch ex As Exception
            Return Nothing
        End Try

    End Function
    Public Function insertarWithoutID(ByVal strSql As String) As Boolean
        Dim Rs As New SqlCommand
        Dim con As New SqlConnection
        Dim tran As SqlTransaction

        Dim blnRes As Boolean = False

        Try
            ' Recupero la cadena de connexió a la BBDD
            con.ConnectionString = ConnectionString
            con.Open()
            tran = con.BeginTransaction

            ' Assigno la consulta a l'objecte Command
            Rs.CommandText = strSql
            ' Estableixo el temps màxim de recuperació de la consulta avanç de donar error
            Rs.CommandTimeout = 300
            ' Estableixo el tipos de consulta
            Rs.CommandType = CommandType.Text
            ' Assigno i obro la connexió
            Rs.Connection = con
            Rs.Transaction = tran


            Try
                Rs.ExecuteNonQuery()
                tran.Commit()
                tran.Dispose()

                Rs.Dispose()
                blnRes = True

            Catch ex As Exception
                tran.Rollback()
                tran.Dispose()
                Rs.Dispose()
            End Try

            Return blnRes

        Catch ex As Exception
            Return False
        Finally
            tran = Nothing
            Rs = Nothing
            If con.State = ConnectionState.Open Then con.Close()
            con = Nothing
        End Try

    End Function
    Public Function update(ByVal strSql As String) As Boolean
        Dim Rs As New SqlCommand
        Dim con As New SqlConnection
        Dim tran As SqlTransaction

        Dim blnRes As Boolean = False

        Try
            ' Recupero la cadena de connexió a la BBDD
            'con.ConnectionString = System.Configuration.ConfigurationManager.ConnectionStrings("CentreFormacio.ConnStr").ToString()
            con.ConnectionString = ConnectionString
            con.Open()
            tran = con.BeginTransaction

            ' Assigno la consulta a l'objecte Command
            Rs.CommandText = strSql
            ' Estableixo el temps màxim de recuperació de la consulta avanç de donar error
            Rs.CommandTimeout = 300
            ' Estableixo el tipos de consulta
            Rs.CommandType = CommandType.Text
            ' Assigno i obro la connexió
            Rs.Connection = con
            Rs.Transaction = tran

            Try
                Rs.ExecuteNonQuery()
                tran.Commit()
                tran.Dispose()
                Rs.Dispose()

                blnRes = True
            Catch ex As Exception
                tran.Rollback()
                tran.Dispose()
                Rs.Dispose()

                blnRes = False
            End Try

            Return blnRes

        Catch ex As Exception
            Return False
        Finally
            tran = Nothing
            Rs = Nothing
            If con.State = ConnectionState.Open Then con.Close()
            con = Nothing
        End Try

    End Function
    Public Function delete(ByVal strSql As String) As Boolean
        Dim Rs As New SqlCommand
        Dim con As New SqlConnection
        'Dim tran As SqlTransaction

        Dim blnRes As Boolean = False

        Try
            ' Recupero la cadena de connexió a la BBDD
            con.ConnectionString = ConnectionString
            con.Open()
            'tran = con.BeginTransaction

            ' Assigno la consulta a l'objecte Command
            Rs.CommandText = strSql
            ' Estableixo el temps màxim de recuperació de la consulta avanç de donar error
            'Rs.CommandTimeout = 300
            ' Estableixo el tipos de consulta
            Rs.CommandType = CommandType.Text
            ' Assigno i obro la connexió
            Rs.Connection = con
            'Rs.Transaction = tran

            Try
                Rs.ExecuteNonQuery()
                'tran.Commit()
                'tran.Dispose()
                Rs.Dispose()

                blnRes = True
            Catch ex As Exception
                'tran.Rollback()
                'tran.Dispose()
                Rs.Dispose()

                blnRes = False
            End Try

            Return blnRes
        Catch ex As Exception
            Return False
        Finally
            'tran = Nothing
            Rs = Nothing
            If con.State = ConnectionState.Open Then con.Close()
            con = Nothing
        End Try

    End Function
    
End Class

