﻿Imports CercaFeina.business
Imports CercaFeina.common
Imports System.Data.SqlClient
Public Class PageJob
    Inherits System.Web.UI.Page

    Dim jobActual As Job
    Dim job As New JobF
    Dim usrActual As User
    Dim comActual As Company
    Dim comp As New CompanyF

    Private Sub PageJob_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        usrActual = Session("usr")
        If IsNothing(usrActual) Then
            btnRegister.Enabled = False
        Else
            btnRegister.Enabled = True
        End If
        ' Carrego les dades de la oferta de treball seleccionada
        If IsNothing(Request("idJob")) Then Response.Redirect("~/Blank.aspx")
        If Not IsPostBack Then
            jobActual = job.getJobById(Request("idJob"))
            comActual = comp.getById(jobActual.Company)
            LoadCmbCategories()
            LoadCmbContract()
            LoadProvinces()
            LoadJob(jobActual)
            LoadTotalCandidatures(Request("idJob"))
            LoadPhoto(comActual)
        End If
    End Sub
    Protected Sub LoadPhoto(comActual As Company)
        Dim docu As New DocumentF
        Dim path As New ProcessStartInfo
        Dim file As String

        path.FileName = docu.getPath(comActual.Logo)
        If Not (path.FileName = "") Then
            file = path.FileName.Remove(0, 107)
            Photograph.ImageUrl = "~/4.Upload/" & comActual.CompanyId & "/" & file

        End If
    End Sub
    Private Sub LoadTotalCandidatures(jobId As Integer)
        Dim job As New JobF
        Dim dr As SqlDataReader

        dr = job.getCountCandidaturesByJob(jobId)
        If dr.HasRows Then
            While dr.Read()
                lblTotalPeople.Text = dr.GetInt32(0)
            End While
            dr.Close()
        End If
    End Sub
    Protected Sub LoadCmbCategories()
        Dim job As New JobF
        Dim dr As SqlDataReader
        'Carregar la combo de ciutat segons la provincia seleccionada
        cmbCategory.Items.Clear()
        dr = job.getAllCategories
        If dr.HasRows Then
            While dr.Read()
                cmbCategory.Items.Add(dr.Item(0))
            End While
            dr.Close()
        End If
    End Sub
    Protected Sub LoadCmbContract()
        Dim job As New JobF
        Dim dr As SqlDataReader
        'Carregar la combo de ciutat segons la provincia seleccionada
        cmbContract.Items.Clear()
        dr = job.getAllContract
        If dr.HasRows Then
            While dr.Read()
                cmbContract.Items.Add(dr.Item(0))
            End While
            dr.Close()
        End If
    End Sub

    Protected Sub LoadJob(jobActual As Job)
        Dim job As New JobF

        lblJobId.Text = jobActual.JobId
        lblJobName.Text = jobActual.JobName
        txtData.Text = jobActual.Activation_date
        txtCompanyName.Text = jobActual.CompanyName
        txtDescription.Text = jobActual.DescriptionCompany
        txtCity.Text = jobActual.City
        txtJobName.Text = jobActual.JobName
        txtVacancy.Text = jobActual.Vacancy
        txtJobDescription.Text = jobActual.Description
        txtWorkingDay.Text = jobActual.WorkingDay
        txtSalary.Text = jobActual.Salary
        txtBonus.Text = jobActual.Bonus

        cmbCategory.SelectedIndex = jobActual.CategoryId - 1
        cmbContract.SelectedIndex = jobActual.ContractId - 1

        txtMininumExperience.Text = jobActual.Minimum_experience
        txtMininumRequeriments.Text = jobActual.Minimum_requeriments
        txtMiniumStudy.Text = jobActual.Minimum_education
        txtDesiredRequeriments.Text = jobActual.Desired_requeriments

    End Sub
    Protected Sub LoadProvinces()
        Dim usuari As New UserF
        Dim dr As SqlDataReader

        cmbProvince.Items.Clear()
        dr = usuari.getAllProvinces
        If dr.HasRows Then
            While dr.Read()
                cmbProvince.Items.Add(dr.Item(0))
            End While
            dr.Close()
        End If
        cmbProvince.Text = jobActual.Province

        cmbCity.Items.Clear()
        dr = usuari.getCitiesByProvince(cmbProvince.Text)
        If dr.HasRows Then
            While dr.Read()
                cmbCity.Items.Add(dr.Item(0))
            End While
            dr.Close()
        End If
        cmbCity.Text = jobActual.CityName

    End Sub
    Protected Sub btnAdditionalInformation_Click(sender As Object, e As EventArgs) Handles btnAdditionalInformation.Click
        If txtDescription.Visible = False Then
            'Mostrar el text de Informació addicional
            txtDescription.Visible = True
        Else
            'Ocultar el text de Informació addicional
            txtDescription.Visible = False
        End If
    End Sub

    Protected Sub btnRegister_Click(sender As Object, e As EventArgs) Handles btnRegister.Click
        Response.Redirect("~/1.Jobs/RegisterJob.aspx?idUsuari=" & usrActual.userId & "&idJob=" & Request("idJob"))
    End Sub

    Protected Sub btnGoForward_Click(sender As Object, e As EventArgs) Handles btnGoForward.Click
        Response.Redirect("~/1.Jobs/DefaultJobs.aspx")
    End Sub
End Class