﻿Imports CercaFeina.business
Imports CercaFeina.common
Imports System.Data.SqlClient
Public Class AddJob
    Inherits System.Web.UI.Page
    Dim usuari As New UserF
    Dim jobActual As Job
    Dim usrActual As Company
    Dim usr As User


    Private Sub AddJob_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        usrActual = Session("usr")
        ' Carrego les dades de la oferta de treball seleccionada
        If IsNothing(usrActual) Then Response.Redirect("~/Blank.aspx")
        If Not IsPostBack Then
            LoadCmbCategories()
            LoadCmbContract()
            LoadCmbProvinces()
            If Not IsNothing(Request("idJob")) Then
                'Modificar una cerca existent
                LoadDataSearch()
                btnSave.Visible = True
                btnAdd.Visible = False
            End If
        End If
    End Sub
    Private Sub LoadDataSearch()
        Dim njob As Job
        Dim job As New JobF

        njob = job.getJobById(Request("idJob"))
        'Mostrar les dades de la cerca
        lblIdJob.Text = njob.JobId.ToString
        txtJobName.Text = njob.JobName.ToString
        cmbCategory.SelectedIndex = njob.CategoryId
        txtVacancy.Text = njob.Vacancy.ToString
        txtJobDescription.Text = njob.Description.ToString
        txtCity.Text = njob.City.ToString
        cmbProvince.SelectedValue = njob.Province
        cmbProvince_SelectedIndexChanged(Nothing, Nothing)
        cmbCity.SelectedValue = njob.CityName
        cmbContract.SelectedIndex = njob.ContractId
        txtWorkingDay.Text = njob.WorkingDay.ToString
        txtSalary.Text = njob.Salary.ToString
        txtBonus.Text = njob.Bonus.ToString
        txtMininumRequeriments.Text = njob.Minimum_requeriments.ToString
        txtDesiredRequeriments.Text = njob.Desired_requeriments.ToString
        txtMininumExperience.Text = njob.Minimum_experience.ToString
        txtMiniumStudy.Text = njob.Minimum_education.ToString
    End Sub
    Protected Sub LoadCmbCategories()
        Dim job As New JobF
        Dim dr As SqlDataReader
        'Carregar la combo de ciutat segons la provincia seleccionada
        cmbCategory.Items.Clear()
        dr = job.getAllCategories
        If dr.HasRows Then
            While dr.Read()
                cmbCategory.Items.Add(dr.Item(0))
            End While
            dr.Close()
        End If
    End Sub
    Protected Sub LoadCmbContract()
        Dim job As New JobF
        Dim dr As SqlDataReader
        'Carregar la combo de ciutat segons la provincia seleccionada
        cmbContract.Items.Clear()
        dr = job.getAllContract
        If dr.HasRows Then
            While dr.Read()
                cmbContract.Items.Add(dr.Item(0))
            End While
            dr.Close()
        End If
    End Sub
    Protected Sub LoadCmbProvinces()
        Dim usuari As New UserF
        Dim dr As SqlDataReader

        'Carregar la combo de ciutat segons la provincia seleccionada
        cmbProvince.Items.Clear()
        dr = usuari.getAllProvinces
        If dr.HasRows Then
            While dr.Read()
                cmbProvince.Items.Add(dr.Item(0))
            End While
            dr.Close()
        End If
        cmbProvince.Text = "Sense especificar"
        'Carregar la combo de ciutat segons la provincia seleccionada
        cmbCity.Items.Clear()
        dr = usuari.getCitiesByProvince(cmbProvince.Text)
        If dr.HasRows Then
            While dr.Read()
                cmbCity.Items.Add(dr.Item(0))
            End While
            dr.Close()
        End If
        cmbCity.Text = "Sense especificar"
    End Sub
    Protected Sub cmbProvince_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cmbProvince.SelectedIndexChanged
        Dim usuari As New UserF
        Dim dr As SqlDataReader
        'Carregar la combo de ciutat segons la provincia seleccionada
        cmbCity.Items.Clear()
        dr = usuari.getCitiesByProvince(cmbProvince.Text)
        If dr.HasRows Then
            While dr.Read()
                cmbCity.Items.Add(dr.Item(0))
            End While
            dr.Close()
        End If
    End Sub
    Protected Sub LoadJob(jobActual As Job)
        Dim job As New JobF

        txtCity.Text = jobActual.City
        txtJobName.Text = jobActual.JobName
        txtVacancy.Text = jobActual.Vacancy
        txtJobDescription.Text = jobActual.Description
        txtWorkingDay.Text = jobActual.WorkingDay
        txtSalary.Text = jobActual.Salary
        txtBonus.Text = jobActual.Bonus

        cmbCategory.SelectedIndex = jobActual.CategoryId - 1
        cmbContract.SelectedIndex = jobActual.ContractId - 1

        txtMininumExperience.Text = jobActual.Minimum_experience
        txtMininumRequeriments.Text = jobActual.Minimum_requeriments
        txtMiniumStudy.Text = jobActual.Minimum_education
        txtDesiredRequeriments.Text = jobActual.Desired_requeriments

    End Sub
    Protected Sub btnAdd_Click(sender As Object, e As EventArgs) Handles btnAdd.Click
        Dim job As New JobF
        Dim jobC As New Job
        Dim jobE As Job

        txtCity.Text = usuari.getProvinceIdByCity(cmbCity.Text.ToString)

        jobC.Company = usrActual.CompanyId
        jobC.JobName = txtJobName.Text
        jobC.Description = txtJobDescription.Text
        If txtVacancy.Text = "" Then
            MsgBox("Es obligatori omplir la casella de numero de vacants", vbOK)
            txtVacancy.Focus()
            Exit Sub
        Else
            jobC.Vacancy = Convert.ToInt32(txtVacancy.Text)
        End If
        jobC.ContractId = cmbContract.SelectedIndex
        jobC.Salary = txtSalary.Text
        jobC.Bonus = txtBonus.Text
        jobC.City = txtCity.Text
        jobC.Minimum_requeriments = txtMininumRequeriments.Text
        jobC.Desired_requeriments = txtDesiredRequeriments.Text
        jobC.Minimum_experience = txtMininumExperience.Text
        jobC.Minimum_education = txtMiniumStudy.Text
        jobC.WorkingDay = txtWorkingDay.Text
        jobC.CategoryId = cmbCategory.SelectedIndex
        jobC.Activation_date = Now

        jobE = job.insertJob(jobC)

        If Not IsNothing(jobC) Then
            Response.Redirect("~/3.Companies/PersonalJobs.aspx")
        Else
            Response.Redirect("~/3.Companies/ErrorAddJob.aspx")
        End If
    End Sub

    Protected Sub btnSave_Click(sender As Object, e As EventArgs) Handles btnSave.Click
        Dim job As New JobF
        Dim jobC As New Job
        Dim jobE As Job

        txtCity.Text = usuari.getProvinceIdByCity(cmbCity.Text.ToString)

        jobC.JobId = lblIdJob.Text
        jobC.Company = usrActual.CompanyId
        jobC.JobName = txtJobName.Text
        jobC.Description = txtJobDescription.Text
        If txtVacancy.Text = "" Then
            MsgBox("Es obligatori omplir la casella de numero de vacants", vbOK)
            txtVacancy.Focus()
            Exit Sub
        Else
            jobC.Vacancy = Convert.ToInt32(txtVacancy.Text)
        End If
        jobC.ContractId = cmbContract.SelectedIndex
        jobC.Salary = txtSalary.Text
        jobC.Bonus = txtBonus.Text
        jobC.City = txtCity.Text
        jobC.Minimum_requeriments = txtMininumRequeriments.Text
        jobC.Desired_requeriments = txtDesiredRequeriments.Text
        jobC.Minimum_experience = txtMininumExperience.Text
        jobC.Minimum_education = txtMiniumStudy.Text
        jobC.WorkingDay = txtWorkingDay.Text
        jobC.CategoryId = cmbCategory.SelectedIndex
        jobC.Activation_date = Now

        jobE = job.updateJob(jobC)

        If Not IsNothing(jobC) Then
            Response.Redirect("~/3.Companies/PersonalJobs.aspx")
        Else
            Response.Redirect("~/3.Companies/ErrorAddJob.aspx")
        End If
    End Sub
End Class
