﻿Imports CercaFeina.business
Imports CercaFeina.common
Imports System.Data.SqlClient
Imports System.IO


Public Class Curriculum
    Inherits System.Web.UI.Page
    Dim usrActual As User
    Dim path As String = ""
    Dim documentE As New Document
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        usrActual = Session("usr")
        If IsNothing(usrActual) Then Response.Redirect("~/Blank.aspx")
        If Not IsPostBack Then
            LoadCmbProvinces()
            LoadPersonalInformation(usrActual)
            LoadGridStudies(usrActual)
            LoadGridExperience(usrActual)
            LoadGridSkills(usrActual)
            LoadGridCartesPresen(usrActual)
            LoadGridCartesReco(usrActual)
            LoadGridCurriculum(usrActual)
            LoadGridCertificates(usrActual)
            LoadPhoto(usrActual)
        End If
    End Sub
    Protected Sub LoadPersonalInformation(usrActual As User)
        Dim usuari As New UserF
        Dim dr As SqlDataReader

        txtId.Text = usrActual.userId
        txtName.Text = usrActual.Name
        txtSurnames.Text = usrActual.Surnames
        txtAddress.Text = usrActual.Address
        txtCity.Text = usrActual.City
        txtPostalCode.Text = usrActual.Postal_code
        txtBirthDate.Text = usrActual.Date_birth
        txtEmail.Text = usrActual.Email
        txtMobile.Text = usrActual.Mobile
        txtTelephone.Text = usrActual.Phone
        Select Case usrActual.Marital_status
            Case 0 'Solter
                cmbMaritalStatus.SelectedIndex = 0
            Case 1 'Casat
                cmbMaritalStatus.SelectedIndex = 1
            Case 2 'Divorciat
                cmbMaritalStatus.SelectedIndex = 2
            Case 3 'Vidu
                cmbMaritalStatus.SelectedIndex = 3
        End Select
        If usrActual.Gender = True Then
            rdMan.Checked = True
        Else
            rdWoman.Checked = True
        End If
        If usrActual.Personal_car = True Then
            rdYes.Checked = True
        Else
            rdNo.Checked = True
        End If
        txtAdditionalInformation.Text = usrActual.additionalInformation
        ' Carrego les opciones dels tipus de carnets de conduir
        dr = usuari.getAllCarType(txtId.Text)
        If dr.HasRows Then
            While dr.Read()
                Select Case RTrim(dr.Item(1))
                    Case Is = "A"
                        rdA.Checked = True
                    Case Is = "A1"
                        rdA1.Checked = True
                    Case Is = "B"
                        rdB.Checked = True
                    Case Is = "BE"
                        rdBE.Checked = True
                    Case Is = "btp"
                        rdbtp.Checked = True
                    Case Is = "C"
                        rdC.Checked = True
                    Case Is = "C1"
                        rdC1.Checked = True
                    Case Is = "C1E"
                        rdC1E.Checked = True
                    Case Is = "CE"
                        rdCE.Checked = True
                    Case Is = "D"
                        rdD.Checked = True
                    Case Is = "D1"
                        rdD1.Checked = True
                    Case Is = "D1E"
                        rdD1E.Checked = True
                    Case Is = "DE"
                        rdDE.Checked = True
                End Select
            End While
            dr.Close()
        End If
    End Sub
    Protected Sub LoadGridStudies(usrActual As User)
        Dim user As New UserF
        Dim dr As SqlDataReader

        dr = user.getAllStudies(usrActual.userId)
        ' Carrego les dades al gridview
        grdStudies.DataSource = dr
        grdStudies.DataBind()
    End Sub
    Protected Sub LoadGridExperience(usrActual As User)
        Dim user As New UserF
        Dim dr As SqlDataReader

        dr = user.getAllExperience(usrActual.userId)
        ' Carrego les dades al gridview
        grdExperience.DataSource = dr
        grdExperience.DataBind()
    End Sub
    Protected Sub LoadGridSkills(usrActual As User)
        Dim user As New UserF
        Dim dr As SqlDataReader

        dr = user.getSkillsByUser(usrActual.userId)
        ' Carrego les dades al gridview
        grdSkills.DataSource = dr
        grdSkills.DataBind()
    End Sub
    Protected Sub LoadGridCartesPresen(usrActual As User)
        Dim docu As New DocumentF
        Dim dr As SqlDataReader

        dr = docu.getAllCartesPresenByUser(usrActual.userId)
        ' Carrego les dades al gridview
        grdCartesPresen.DataSource = dr
        grdCartesPresen.DataBind()
    End Sub
    Protected Sub LoadGridCartesReco(usrActual As User)
        Dim docu As New DocumentF
        Dim dr As SqlDataReader

        dr = docu.getAllCartesRecoByUser(usrActual.userId)
        ' Carrego les dades al gridview
        grdCartesReco.DataSource = dr
        grdCartesReco.DataBind()
    End Sub
    Protected Sub LoadGridCurriculum(usrActual As User)
        Dim docu As New DocumentF
        Dim dr As SqlDataReader

        dr = docu.getAllCurriculumByUser(usrActual.userId)
        ' Carrego les dades al gridview
        grdCurriculums.DataSource = dr
        grdCurriculums.DataBind()
    End Sub
    Protected Sub LoadGridCertificates(usrActual As User)
        Dim docu As New DocumentF
        Dim dr As SqlDataReader

        dr = docu.getAllCertificatesByUser(usrActual.userId)
        ' Carrego les dades al gridview
        grdCertificates.DataSource = dr
        grdCertificates.DataBind()
    End Sub
    Protected Sub LoadPhoto(usrActual As User)
        Dim docu As New DocumentF
        Dim path As New ProcessStartInfo
        Dim file As String


        path.FileName = docu.getPath(usrActual.Photograph)
        If Not (path.FileName = "") Then
            file = path.FileName.Remove(0, 107)
            Photograph.ImageUrl = "~/4.Upload/" & usrActual.userId & "/" & file
        End If
    End Sub
    Protected Sub btnAdditionalInformation_Click(sender As Object, e As EventArgs) Handles btnAdditionalInformation.Click
        If txtAdditionalInformation.Visible = False Then
            'Mostrar el text de Informació addicional
            txtAdditionalInformation.Visible = True
        Else
            'Ocultar el text de Informació addicional
            txtAdditionalInformation.Visible = False
        End If
    End Sub

    Protected Sub btnModify_Click(sender As Object, e As EventArgs) Handles btnModify.Click
        'Habilitar el botó de guardar i tots els objectes modicables.
        btnSave.Visible = True
        btnModify.Visible = False


        txtName.Enabled = True
        txtSurnames.Enabled = True
        txtAddress.Enabled = True
        txtCity.Enabled = True
        txtPostalCode.Enabled = True
        txtCity.Enabled = True
        txtBirthDate.Enabled = True
        txtEmail.Enabled = True
        txtMobile.Enabled = True
        txtTelephone.Enabled = True
        cmbMaritalStatus.Enabled = True
        cmbCity.Enabled = True
        cmbProvince.Enabled = True
        rdMan.Enabled = True
        rdWoman.Enabled = True
        txtAdditionalInformation.Enabled = True
        rdYes.Enabled = True
        rdNo.Enabled = True
        rdA.Enabled = True
        rdA1.Enabled = True
        rdB.Enabled = True
        rdBE.Enabled = True
        rdbtp.Enabled = True
        rdC.Enabled = True
        rdC1.Enabled = True
        rdC1E.Enabled = True
        rdCE.Enabled = True
        rdD.Enabled = True
        rdD1.Enabled = True
        rdD1E.Enabled = True
        rdDE.Enabled = True
        FileUpload1.Visible = True
        btnAddPhoto.Visible = True
        lblMessage.Visible = True
    End Sub

    Protected Sub btnSave_Click(sender As Object, e As EventArgs) Handles btnSave.Click
        Dim usuari As New UserF
        Dim docu As New DocumentF
        'verificar les dades introduides
        txtCity.Text = usuari.getProvinceIdByCity(cmbCity.Text.ToString)

        'Deshabilitar el botó de guardar i tots els objectes modicables.
        btnModify.Visible = True
        btnSave.Visible = False

        txtName.Enabled = False
        txtSurnames.Enabled = False
        txtAddress.Enabled = False
        txtCity.Enabled = False
        txtPostalCode.Enabled = False
        txtBirthDate.Enabled = False
        txtEmail.Enabled = False
        txtMobile.Enabled = False
        txtTelephone.Enabled = False
        cmbMaritalStatus.Enabled = False
        cmbCity.Enabled = False
        cmbProvince.Enabled = False
        rdMan.Enabled = False
        rdWoman.Enabled = False
        txtAdditionalInformation.Enabled = False
        rdYes.Enabled = False
        rdNo.Enabled = False
        rdA.Enabled = False
        rdA1.Enabled = False
        rdB.Enabled = False
        rdBE.Enabled = False
        rdbtp.Enabled = False
        rdC.Enabled = False
        rdC1.Enabled = False
        rdC1E.Enabled = False
        rdCE.Enabled = False
        rdD.Enabled = False
        rdD1.Enabled = False
        rdD1E.Enabled = False
        rdDE.Enabled = False
        FileUpload1.Visible = False
        btnAddPhoto.Visible = False
        lblMessage.Visible = False
        'Guardar els canvis
        usrActual.Name = txtName.Text
        usrActual.Surnames = txtSurnames.Text
        usrActual.Address = txtAddress.Text
        usrActual.City = txtCity.Text
        usrActual.Postal_code = txtPostalCode.Text
        If Not (txtBirthDate.Text = "") Then
            usrActual.Date_birth = txtBirthDate.Text
        End If

        usrActual.Email = txtEmail.Text
        If txtMobile.Text = "" Then
            usrActual.Mobile = 0
        Else
            usrActual.Mobile = txtMobile.Text
        End If
        If txtTelephone.Text = "" Then
            usrActual.Phone = 0
        Else
            usrActual.Phone = txtTelephone.Text
        End If
        Select Case cmbMaritalStatus.SelectedIndex
            Case Is = 0 'Solter
                usrActual.Marital_status = 0
            Case 1 'Casat
                usrActual.Marital_status = 1
            Case 2 'Divorciat
                usrActual.Marital_status = 2
            Case 3 'Vidu
                usrActual.Marital_status = 3
        End Select
        usrActual.additionalInformation = txtAdditionalInformation.Text

        If rdMan.Checked Then
            usrActual.Gender = 0
        Else
            usrActual.Gender = 1
        End If
        If rdYes.Checked Then
            usrActual.Personal_car = 1
        Else
            usrActual.Gender = 0
        End If

        'Eliminació de tots els tipos de carnets
        usuari.delete(usrActual.userId)
        'Insertar tots els carnets marcats
        If rdA.Checked Then
            usrActual.CarType = "A"
            usuari.insertCarType(usrActual)
        End If
        If rdA1.Checked Then
            usrActual.CarType = "A1"
            usuari.insertCarType(usrActual)
        End If
        If rdB.Checked Then
            usrActual.CarType = "B"
            usuari.insertCarType(usrActual)
        End If
        If rdBE.Checked Then
            usrActual.CarType = "BE"
            usuari.insertCarType(usrActual)
        End If
        If rdbtp.Checked Then
            usrActual.CarType = "BTP"
            usuari.insertCarType(usrActual)
        End If
        If rdC.Checked Then
            usrActual.CarType = "C"
            usuari.insertCarType(usrActual)
        End If
        If rdC1.Checked Then
            usrActual.CarType = "C1"
            usuari.insertCarType(usrActual)
        End If
        If rdC1E.Checked Then
            usrActual.CarType = "C1E"
            usuari.insertCarType(usrActual)
        End If
        If rdCE.Checked Then
            usrActual.CarType = "CE"
            usuari.insertCarType(usrActual)
        End If
        If rdD.Checked Then
            usrActual.CarType = "D"
            usuari.insertCarType(usrActual)
        End If
        If rdD1.Checked Then
            usrActual.CarType = "D1"
            usuari.insertCarType(usrActual)
        End If
        If rdD1E.Checked Then
            usrActual.CarType = "D1E"
            usuari.insertCarType(usrActual)
        End If
        If rdDE.Checked Then
            usrActual.CarType = "DE"
            usuari.insertCarType(usrActual)
        End If
        'Guardar modificacions de les dades personals d'usuari
        usuari.update(usrActual)
    End Sub
    Protected Sub LoadCmbProvinces()
        Dim usuari As New UserF
        Dim dr As SqlDataReader


        'Carregar la combo de ciutat segons la provincia seleccionada
        cmbProvince.Items.Clear()
        dr = usuari.getAllProvinces
        If dr.HasRows Then
            While dr.Read()
                cmbProvince.Items.Add(dr.Item(0))
            End While
            dr.Close()
        End If
        cmbProvince.Text = usrActual.Province
        'Carregar la combo de ciutat segons la provincia seleccionada
        cmbCity.Items.Clear()
        dr = usuari.getCitiesByProvince(cmbProvince.Text)
        If dr.HasRows Then
            While dr.Read()
                cmbCity.Items.Add(dr.Item(0))
            End While
            dr.Close()
        End If
        cmbCity.Text = usrActual.CityName

    End Sub
    Protected Sub cmbProvince_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cmbProvince.SelectedIndexChanged
        Dim usuari As New UserF
        Dim dr As SqlDataReader
        'Carregar la combo de ciutat segons la provincia seleccionada
        cmbCity.Items.Clear()
        dr = usuari.getCitiesByProvince(cmbProvince.Text)
        If dr.HasRows Then
            While dr.Read()
                cmbCity.Items.Add(dr.Item(0))
            End While
            dr.Close()
        End If
    End Sub
    Private Sub grdStudies_RowCommand(sender As Object, e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles grdStudies.RowCommand
        Dim user As New UserF

        Select Case e.CommandName
            Case "Editar"
                Response.Redirect("~/2.Users/SubPantalles/AddStudy.aspx?idStudy=" & Convert.ToInt32(e.CommandArgument))
            Case "Eliminar"
                'Elimino els estudis
                user.deleteStudy(System.Convert.ToInt32(e.CommandArgument))
                'Carrego de nou la grid
                LoadGridStudies(usrActual)
        End Select
    End Sub


    Private Sub grdStudies_RowDataBound(sender As Object, e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles grdStudies.RowDataBound
        If e.Row.RowType = DataControlRowType.DataRow Then
            ' Display the company name in italics.
            If e.Row.Cells(7).Text Then
                e.Row.Cells(7).Text = "Finalitzat"
            Else
                e.Row.Cells(7).Text = "En Curs"
            End If
        End If
    End Sub

    Private Sub grdSkills_RowCommand(sender As Object, e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles grdSkills.RowCommand
        Dim user As New UserF

        Select Case e.CommandName
            Case "Editar"
                Response.Redirect("~/2.Users/SubPantalles/AddSkills.aspx?idSkill=" & Convert.ToInt32(e.CommandArgument))
            Case "Eliminar"
                'Elimino les habilitats
                user.deleteSkills(System.Convert.ToInt32(e.CommandArgument))
                'Carrego de nou la grid
                LoadGridSkills(usrActual)
        End Select
    End Sub

    Private Sub grdSkills_RowDataBound(sender As Object, e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles grdSkills.RowDataBound
        If e.Row.RowType = DataControlRowType.DataRow Then
            ' Display the company name in italics.
            Select Case e.Row.Cells(4).Text
                Case 0
                    e.Row.Cells(4).Text = "Baix"
                Case 1
                    e.Row.Cells(4).Text = "Mitg"
                Case 2
                    e.Row.Cells(4).Text = "Alt"
            End Select
        End If
    End Sub

    Private Sub grdExperience_RowCommand(sender As Object, e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles grdExperience.RowCommand
        Dim user As New UserF

        Select Case e.CommandName
            Case "Editar"
                Response.Redirect("~/2.Users/SubPantalles/AddExperience.aspx?idExperience=" & Convert.ToInt32(e.CommandArgument))
            Case "Eliminar"
                'Elimino la experiencia de treball
                user.deleteExperience(System.Convert.ToInt32(e.CommandArgument))
                'Carrego de nou la grid
                LoadGridExperience(usrActual)
        End Select
    End Sub

    Protected Sub btnAddStudies_Click(sender As Object, e As EventArgs) Handles btnAddStudies.Click
        Response.Redirect("~/2.Users/SubPantalles/AddStudy.aspx?idUser=" & usrActual.userId)
    End Sub

    Protected Sub btnAddExperience_Click(sender As Object, e As EventArgs) Handles btnAddExperience.Click
        Response.Redirect("~/2.Users/SubPantalles/AddExperience.aspx?idUser=" & usrActual.userId)
    End Sub

    Protected Sub btnAddSkill_Click(sender As Object, e As EventArgs) Handles btnAddSkill.Click
        Response.Redirect("~/2.Users/SubPantalles/AddSkills.aspx?idUser=" & usrActual.userId)
    End Sub
    Protected Sub btnAddStudies1_Click(sender As Object, e As EventArgs) Handles btnAddDocs.Click
        Response.Redirect("~/2.Users/SubPantalles/AddDocuments.aspx?idUser=" & usrActual.userId)
    End Sub

    Private Sub grdCartesPresen_RowCommand(sender As Object, e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles grdCartesPresen.RowCommand
        Dim docu As New DocumentF

        Select Case e.CommandName
            Case "Ver"
                Dim path As New ProcessStartInfo
                Dim loProces As New Process
                path.FileName = docu.getPath(System.Convert.ToInt32(e.CommandArgument))
                Try
                    loProces = Process.Start(path)
                Catch Exp As Exception
                    MsgBox("Error durant el proces", vbOK)
                End Try
            Case "Eliminar"
                'Elimino el document
                path = docu.getPath(System.Convert.ToInt32(e.CommandArgument))
                docu.deleteDocument(System.Convert.ToInt32(e.CommandArgument))

                'eliminar el document de la carpeta
                Kill(path)
                'Carrego de nou la grid
                LoadGridCartesPresen(usrActual)
        End Select
    End Sub
    Private Sub grdCartesReco_RowCommand(sender As Object, e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles grdCartesReco.RowCommand
        Dim docu As New DocumentF

        Select Case e.CommandName
            Case "Ver"
                Dim path As New ProcessStartInfo
                Dim loProces As New Process
                path.FileName = docu.getPath(System.Convert.ToInt32(e.CommandArgument))
                Try
                    loProces = Process.Start(path)
                Catch Exp As Exception
                    MsgBox("Error durant el proces", vbOK)
                End Try
            Case "Eliminar"

                'Elimino el document
                path = docu.getPath(System.Convert.ToInt32(e.CommandArgument))
                docu.deleteDocument(System.Convert.ToInt32(e.CommandArgument))

                'eliminar el document de la carpeta
                Kill(path)
                'Carrego de nou la grid
                LoadGridCartesReco(usrActual)
        End Select
    End Sub

    Private Sub grdCertificates_RowCommand(sender As Object, e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles grdCertificates.RowCommand
        Dim docu As New DocumentF

        Select Case e.CommandName
            Case "Ver"
                Dim path As New ProcessStartInfo
                Dim loProces As New Process
                path.FileName = docu.getPath(System.Convert.ToInt32(e.CommandArgument))
                Try
                    loProces = Process.Start(path)
                Catch Exp As Exception
                    MsgBox("Error durant el proces", vbOK)
                End Try
            Case "Eliminar"
                'Elimino el document
                path = docu.getPath(System.Convert.ToInt32(e.CommandArgument))
                docu.deleteDocument(System.Convert.ToInt32(e.CommandArgument))

                'eliminar el document de la carpeta
                Kill(path)
                'Carrego de nou la grid
                LoadGridCertificates(usrActual)
        End Select
    End Sub

    Private Sub grdCurriculums_RowCommand(sender As Object, e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles grdCurriculums.RowCommand
        Dim docu As New DocumentF

        Select Case e.CommandName
            Case "Ver"
                Dim path As New ProcessStartInfo
                Dim loProces As New Process
                path.FileName = docu.getPath(System.Convert.ToInt32(e.CommandArgument))
                Try
                    loProces = Process.Start(path)
                Catch Exp As Exception
                    MsgBox("Error durant el proces", vbOK)
                End Try
            Case "Eliminar"
                'Elimino el document
                path = docu.getPath(System.Convert.ToInt32(e.CommandArgument))
                docu.deleteDocument(System.Convert.ToInt32(e.CommandArgument))

                'eliminar el document de la carpeta
                Kill(path)
                'Carrego de nou la grid
                LoadGridCurriculum(usrActual)
        End Select
    End Sub


    Protected Sub btnAddPhoto_Click(sender As Object, e As EventArgs) Handles btnAddPhoto.Click
        lblMessage.Text = ""
        ' Before attempting to save the file, verify
        ' that the FileUpload control contains a file.
        If (FileUpload1.HasFile) Then
            ' Call a helper method routine to save the file.
            SaveFile(FileUpload1.PostedFile)
            LoadPhoto(usrActual)
        Else
            ' Notify the user that a file was not uploaded.
            lblMessage.Text = "No ha especificat cap document."
        End If
    End Sub


    Sub SaveFile(ByVal file As HttpPostedFile)
        Dim docu As New DocumentF
        Dim usuari As New UserF

        'Verificar si existeix les carpetes
        If Not (Directory.Exists(Server.MapPath("~/4.Upload/" & usrActual.userId & "/"))) Then
            Directory.CreateDirectory(Server.MapPath("~/4.Upload/" & usrActual.userId & "/"))
        End If
        ' Specify the path to save the uploaded file to.
        Dim savePath As String = Server.MapPath("~/4.Upload/" & usrActual.userId & "/")
        ' Get the name of the file to upload.
        Dim fileName As String = FileUpload1.FileName

        ' Append the name of the file to upload to the path.
        savePath += fileName

        ' Call the SaveAs method to save the uploaded
        ' file to the specified directory.
        FileUpload1.SaveAs(savePath)
        If (usrActual.Photograph <> "") Then
            'Elimino el fitxer
            path = docu.getPath(usrActual.Photograph)
            Kill(path)
            'Elimino la ruta de la base de dades
            docu.deleteDocument(usrActual.Photograph)
        End If
        documentE.type = Document.enType.Photo
        documentE.UserId = usrActual.userId
        documentE.Path = savePath
        documentE.Description = "Photograph"
        docu.insert(documentE)
        usrActual.Photograph = docu.getPhotoById(usrActual.userId)
        usuari.updatePhoto(usrActual)
        LoadPhoto(usrActual)

        ' Notify the user that the file was saved successfully.
        lblMessage.Text = "El teu document s'ha guardat correctament."
    End Sub
End Class




