﻿Imports CercaFeina.business
Imports CercaFeina.common
Imports System.Data.SqlClient
Public Class PersonalJobs
    Inherits System.Web.UI.Page
    Dim usrActual As Company
    Dim nCountTotal As Integer
    Dim candidat As New CandidatureF
    'Estat de les ofertes i dels candidats
    Dim state As Integer = 4
    Dim candidatActual As User
    Dim candidatureActual As Candidature
    Dim job As New JobF
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        usrActual = Session("usr")
        If IsNothing(usrActual) Then Response.Redirect("~/Blank.aspx")
        If Not IsPostBack Then
            LoadGridJobs(usrActual, state)
        End If
    End Sub
    'Carregar la grid d'ofertes de treball que té la empresa activa
    Protected Sub LoadGridJobs(usrActual As Company, state As Integer)
        Dim dr As SqlDataReader
        Dim fld As BoundField = Nothing

        dr = job.getJobsByCompany(usrActual.CompanyId, state)
        ' Carrego les dades al gridview
        grdJobs.DataSource = dr
        grdJobs.DataBind()
    End Sub
    Protected Sub LoadGridCertificates(candidatActual As User)
        Dim docu As New DocumentF
        Dim dr As SqlDataReader

        dr = docu.getAllCertificatesByUser(candidatActual.userId)
        ' Carrego les dades al gridview
        grdCertificates.DataSource = dr
        grdCertificates.DataBind()
    End Sub
    Protected Sub LoadGridCurriculums(usrActual As User)
        Dim docu As New DocumentF
        Dim dr As SqlDataReader

        dr = docu.getCurriculumById(candidatureActual.Curriculum)
        ' Carrego les dades al gridview
        grdCurriculums.DataSource = dr
        grdCurriculums.DataBind()
    End Sub
    Protected Sub LoadGridCartes(usrActual As User)
        Dim docu As New DocumentF
        Dim dr As SqlDataReader

        dr = docu.getCartaPresenById(candidatureActual.Letter)
        ' Carrego les dades al gridview
        grdCartesPresen.DataSource = dr
        grdCartesPresen.DataBind()
    End Sub
    'Recontar candidatures totals de cada oferta de treball
    Private Sub LoadTotalCandidatures(jobId As Integer)
        Dim job As New JobF
        Dim dr As SqlDataReader

        dr = job.getCountCandidaturesByJob(jobId)
        If dr.HasRows Then
            While dr.Read()
                nCountTotal = dr.GetInt32(0)
            End While
            dr.Close()
        End If
    End Sub
    'Carregar la grid amb els candidats de l'oferta seleccionada
    Private Sub LoadCandidats(jobId As Integer, state As Integer)
        Dim candidature As New CandidatureF
        Dim dr As SqlDataReader
        Dim fld As BoundField = Nothing

        dr = candidature.getCandidaturesByJob(jobId, state)
        ' Carrego les dades al gridview
        grdCandidates.DataSource = dr
        grdCandidates.DataBind()
    End Sub
    'Carregar les dades personals del candidat seleccionat de la grid
    Private Sub LoadPersonalCandidats(user As String)
        Dim usuari As New UserF
        Dim candidat As New CandidatureF
        Dim dr As SqlDataReader

        candidatActual = usuari.getByIdByPwd(user, "")
        txtId.Text = candidatActual.userId
        txtName.Text = candidatActual.Name
        txtSurnames.Text = candidatActual.Surnames
        txtAddress.Text = candidatActual.Address
        txtCity.Text = candidatActual.City
        txtPostalCode.Text = candidatActual.Postal_code
        txtBirthDate.Text = candidatActual.Date_birth
        txtEmail.Text = candidatActual.Email
        txtMobile.Text = candidatActual.Mobile
        txtTelephone.Text = candidatActual.Phone

        Select Case candidatActual.Marital_status
            Case 0 'Solter
                cmbMaritalStatus.SelectedIndex = 0
            Case 1 'Casat
                cmbMaritalStatus.SelectedIndex = 1
            Case 2 'Divorciat
                cmbMaritalStatus.SelectedIndex = 2
            Case 3 'Vidu
                cmbMaritalStatus.SelectedIndex = 3
        End Select
        If candidatActual.Gender = True Then
            rdMan.Checked = True
        Else
            rdWoman.Checked = True
        End If
        If candidatActual.Personal_car = True Then
            rdYes.Checked = True
        Else
            rdNo.Checked = True
        End If
        txtAdditionalInformation.Text = candidatActual.additionalInformation
        ' Carrego les opciones dels tipus de carnets de conduir
        dr = usuari.getAllCarType(txtId.Text)
        If dr.HasRows Then
            While dr.Read()
                Select Case RTrim(dr.Item(1))
                    Case Is = "A"
                        rdA.Checked = True
                    Case Is = "A1"
                        rdA1.Checked = True
                    Case Is = "B"
                        rdB.Checked = True
                    Case Is = "BE"
                        rdBE.Checked = True
                    Case Is = "btp"
                        rdbtp.Checked = True
                    Case Is = "C"
                        rdC.Checked = True
                    Case Is = "C1"
                        rdC1.Checked = True
                    Case Is = "C1E"
                        rdC1E.Checked = True
                    Case Is = "CE"
                        rdCE.Checked = True
                    Case Is = "D"
                        rdD.Checked = True
                    Case Is = "D1"
                        rdD1.Checked = True
                    Case Is = "D1E"
                        rdD1E.Checked = True
                    Case Is = "DE"
                        rdDE.Checked = True
                End Select
            End While
            dr.Close()
        End If
    End Sub
    'Carregar la combo de provincies i ciutats
    Protected Sub LoadCmbProvinces()
        Dim usuari As New UserF
        Dim dr As SqlDataReader

        cmbProvince.Items.Clear()
        dr = usuari.getAllProvinces
        If dr.HasRows Then
            While dr.Read()
                cmbProvince.Items.Add(dr.Item(0))
            End While
            dr.Close()
        End If
        cmbProvince.Text = candidatActual.Province
        'Carregar la combo de ciutat segons la provincia seleccionada
        cmbCity.Items.Clear()
        dr = usuari.getCitiesByProvince(cmbProvince.Text)
        If dr.HasRows Then
            While dr.Read()
                cmbCity.Items.Add(dr.Item(0))
            End While
            dr.Close()
        End If
        cmbCity.Text = candidatActual.CityName

    End Sub
    'Buidar la grid de candidats
    Private Sub DeleteDataGridCandidats()
        grdCandidates.DataSource = Nothing
        grdCandidates.DataBind()
    End Sub
    Protected Sub LoadPhoto(usrActual As User)
        Dim docu As New DocumentF
        Dim path As New ProcessStartInfo
        Dim file As String


        path.FileName = docu.getPath(candidatActual.Photograph)
        If Not (path.FileName = "") Then
            file = path.FileName.Remove(0, 107)
            Photograph.ImageUrl = "~/4.Upload/" & usrActual.userId & "/" & file
        End If
    End Sub
    'Buidar les dades personals del candidat
    Private Sub DeletePersonalDataCandidat()
        lblCandidat.Text = ""
        lblState.Text = ""
        lblCandidature.Text = ""

        Photograph.ImageUrl = ""
        txtInfoCandidatura.Text = ""
        txtId.Text = ""
        txtName.Text = ""
        txtSurnames.Text = ""
        txtAddress.Text = ""
        txtCity.Text = ""
        txtPostalCode.Text = ""
        txtBirthDate.Text = ""
        txtEmail.Text = ""
        txtMobile.Text = ""
        txtTelephone.Text = ""
        'cmbMaritalStatus.Text = ""

        'Buidar les combos
        cmbProvince.Items.Clear()
        cmbCity.Items.Clear()

        rdMan.Checked = False
        rdWoman.Checked = False
        rdYes.Checked = False
        rdNo.Checked = False
        txtAdditionalInformation.Text = ""
        rdA.Checked = False
        rdA1.Checked = False
        rdB.Checked = False
        rdBE.Checked = False
        rdbtp.Checked = False
        rdC.Checked = False
        rdC1.Checked = False
        rdC1E.Checked = False
        rdCE.Checked = False
        rdD.Checked = False
        rdD1.Checked = False
        rdD1E.Checked = False
        rdDE.Checked = False

        'Eliminar les dades de les grids d'estudis i experencies del candidat
        grdStudies.DataSource = Nothing
        grdStudies.DataBind()
        grdExperience.DataSource = Nothing
        grdExperience.DataBind()

        btnUserDiscard.Enabled = False
        btnUserPreSelected.Enabled = False
        btnUserSelected.Enabled = False

    End Sub
    'Mostrar la informació adicional del candidat
    Protected Sub btnAdditionalInformation_Click(sender As Object, e As EventArgs) Handles btnAdditionalInformation.Click
        If txtAdditionalInformation.Visible = False Then
            'Mostrar el text de Informació addicional
            txtAdditionalInformation.Visible = True
        Else
            'Ocultar el text de Informació addicional
            txtAdditionalInformation.Visible = False
        End If
    End Sub
    'Seleccionar el estat de l'oferta mentres que omple la grid i inserir el total de candidats.
    Private Sub grdJobs_RowDataBound(sender As Object, e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles grdJobs.RowDataBound
        If e.Row.RowType = DataControlRowType.DataRow Then
            'Si no té data de inactivació, la oferta esta activa, si no esta finalitzada
            If e.Row.Cells(6).Text = "&nbsp;" Then
                e.Row.Cells(6).Text = "Activa"
            Else
                e.Row.Cells(6).Text = "Finalitzada"
            End If
            'Omplir el total d'inscrits en cada oferta
            If e.Row.Cells(2).Text <> "" Then
                LoadTotalCandidatures(e.Row.Cells(2).Text)
                e.Row.Cells(7).Text = nCountTotal
            End If
        End If
    End Sub
    'Mostrar els candidats de la oferta seleccionada
    Private Sub grdJobs_RowCommand(sender As Object, e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles grdJobs.RowCommand
        Dim job As New JobF
        Dim idJob As Integer
        Select Case e.CommandName
            Case "Ver"
                DeletePersonalDataCandidat()
                'Mostrar los candidatos
                LoadCandidats(Convert.ToInt32(e.CommandArgument), state)
                lblJobId.Text = Convert.ToInt32(e.CommandArgument)
                'Activar botons dels candidats
                LoadButtonsCandidats()
            Case "Editar"
                Response.Redirect("~/1.Jobs/SubPantalles/AddJob.aspx?idCompany=" & usrActual.CompanyId & "&idjob=" & Convert.ToInt32(e.CommandArgument))
            Case "Eliminar"
                'Elimino la oferta seleccionada
                idJob = System.Convert.ToInt32(e.CommandArgument)
                job.deleteCandidaturesByJob(idJob)
                job.deleteJob(idJob)
                'Carrego de nou la grid
                LoadGridJobs(usrActual, state)
        End Select
    End Sub
    Private Sub LoadButtonsCandidats()
        btnAllCandidatures.Enabled = True
        btnCandidatureDiscard.Enabled = True
        btnCandidaturePendent.Enabled = True
        btnCandidaturePreSelection.Enabled = True
        btnCandidatureSelected.Enabled = True
    End Sub
    Private Sub UnLoadButtonsCandidats()
        btnAllCandidatures.Enabled = False
        btnCandidatureDiscard.Enabled = False
        btnCandidaturePendent.Enabled = False
        btnCandidaturePreSelection.Enabled = False
        btnCandidatureSelected.Enabled = False
    End Sub
    'Mostrar les dades del candidat seleccionat
    Private Sub grdCandidates_RowCommand(sender As Object, e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles grdCandidates.RowCommand
        
        Select Case e.CommandName
            Case "Ver"
                lblCandidat.Text = e.CommandArgument
                'Mostrar les dades del candidat i modificar el CV_read_date amb la data de avui
                LoadPersonalCandidats(lblCandidat.Text)
                LoadCmbProvinces()
                'Modificar 
                candidatureActual = candidat.getCandidatureByUserByJob(lblCandidat.Text, lblJobId.Text)
                candidat.updateCVView(candidatureActual.CandidatureId)
                lblCandidature.Text = candidatureActual.CandidatureId
                txtInfoCandidatura.Text = candidatureActual.Additional_Information
                'Comprovar estat
                StateCandidature(candidatureActual)
                LoadGridStudies(candidatActual)
                LoadGridExperience(candidatActual)
                LoadGridCertificates(candidatActual)
                LoadGridCartes(candidatActual)
                LoadGridCurriculums(candidatActual)
                LoadPhoto(candidatActual)
        End Select
    End Sub

    'Especificar els diferents estats de una candidatura.
    Private Sub grdCandidates_RowDataBound(sender As Object, e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles grdCandidates.RowDataBound
        If e.Row.RowType = DataControlRowType.DataRow Then
            'Si no té data de inactivació, la oferta esta activa, si no esta finalitzada
            Select Case e.Row.Cells(5).Text
                Case 0
                    e.Row.Cells(5).Text = "Pendent"
                    e.Row.Cells(5).ForeColor = Drawing.Color.Orange
                Case 1
                    e.Row.Cells(5).Text = "Descartat"
                    e.Row.Cells(5).ForeColor = Drawing.Color.Red
                Case 2
                    e.Row.Cells(5).Text = "Preseleccionat"
                    e.Row.Cells(5).ForeColor = Drawing.Color.Blue
                Case 3
                    e.Row.Cells(5).Text = "Seleccionat"
                    e.Row.Cells(5).ForeColor = Drawing.Color.Green
            End Select
        End If
    End Sub
    Private Sub StateCandidature(candidatureActual As Candidature)
        Select Case candidatureActual.State
            Case 0
                lblState.Text = "Pendent"
                lblState.ForeColor = Drawing.Color.Orange
                'Activar botons

                btnUserDiscard.Enabled = True
                btnUserPreSelected.Enabled = True
                btnUserSelected.Enabled = True
            Case 1
                lblState.Text = "Descartat"
                lblState.ForeColor = Drawing.Color.Red
                'Activar botons

                btnUserDiscard.Enabled = False
                btnUserPreSelected.Enabled = False
                btnUserSelected.Enabled = False
            Case 2
                lblState.Text = "Preseleccionat"
                lblState.ForeColor = Drawing.Color.Blue
                'Activar botons

                btnUserDiscard.Enabled = True
                btnUserPreSelected.Enabled = False
                btnUserSelected.Enabled = True
            Case 3
                lblState.Text = "Seleccionat"
                lblState.ForeColor = Drawing.Color.Green
                'Activar botons

                btnUserDiscard.Enabled = False
                btnUserPreSelected.Enabled = False
                btnUserSelected.Enabled = False
        End Select
    End Sub

    Protected Sub btnActive_Click(sender As Object, e As EventArgs) Handles btnActive.Click
        UnLoadButtonsCandidats()
        DeletePersonalDataCandidat()
        'Buidar la grid de candidats
        DeleteDataGridCandidats()
        'Eliminar referencia en la label
        lblJobId.Text = ""
        DeleteDataGridCandidats()
        state = 0
        LoadGridJobs(usrActual, state)
    End Sub

    Protected Sub btnAll_Click(sender As Object, e As EventArgs) Handles btnAll.Click
        UnLoadButtonsCandidats()
        DeletePersonalDataCandidat()
        'Buidar la grid de candidats
        DeleteDataGridCandidats()
        'Eliminar referencia en la label
        lblJobId.Text = ""
        DeleteDataGridCandidats()
        state = 4
        LoadGridJobs(usrActual, state)
    End Sub

    Protected Sub btnFinish_Click(sender As Object, e As EventArgs) Handles btnFinish.Click
        UnLoadButtonsCandidats()
        DeletePersonalDataCandidat()
        'Buidar la grid de candidats
        DeleteDataGridCandidats()
        'Eliminar referencia en la label
        lblJobId.Text = ""
        state = 1
        LoadGridJobs(usrActual, state)
    End Sub

    Protected Sub btnAllCandidatures_Click(sender As Object, e As EventArgs) Handles btnAllCandidatures.Click
        'Buidar l'espai personal del candidat
        DeletePersonalDataCandidat()
        state = 4
        LoadCandidats(lblJobId.Text, state)
    End Sub

    Protected Sub btnCandidaturePendent_Click(sender As Object, e As EventArgs) Handles btnCandidaturePendent.Click
        'Buidar l'espai personal del candidat
        DeletePersonalDataCandidat()
        state = 0
        LoadCandidats(lblJobId.Text, state)
    End Sub

    Protected Sub btnCandidaturePreSelection_Click(sender As Object, e As EventArgs) Handles btnCandidaturePreSelection.Click
        'Buidar l'espai personal del candidat
        DeletePersonalDataCandidat()
        state = 2
        LoadCandidats(lblJobId.Text, state)

    End Sub

    Protected Sub btnCandidatureDiscard_Click(sender As Object, e As EventArgs) Handles btnCandidatureDiscard.Click
        'Buidar l'espai personal del candidat
        DeletePersonalDataCandidat()
        state = 1
        LoadCandidats(lblJobId.Text, state)

    End Sub

    Protected Sub btnCandidatureSelected_Click(sender As Object, e As EventArgs) Handles btnCandidatureSelected.Click
        'Buidar l'espai personal del candidat
        DeletePersonalDataCandidat()
        state = 3
        LoadCandidats(lblJobId.Text, state)

    End Sub

    Protected Sub btnUserDiscard_Click(sender As Object, e As EventArgs) Handles btnUserDiscard.Click
        'Modificar l'estat de la candidature a 1 (descartat)
        candidatureActual = candidat.updateStateCandidature(lblCandidature.Text, 1)
        'Modificar l'inactivation de la candidature a NOW
        candidatureActual = candidat.updateDateCandidature(lblCandidature.Text)
        'Buidar les dades personals e inhabilitar els botons
        DeletePersonalDataCandidat()
        btnAllCandidatures_Click(Nothing, Nothing)
    End Sub

    Protected Sub btnUserPreSelected_Click(sender As Object, e As EventArgs) Handles btnUserPreSelected.Click
        'Modificar l'estat de la candidature a 2 (preseleccionat)
        candidatureActual = candidat.updateStateCandidature(lblCandidature.Text, 2)
        'Buidar les dades personals e inhabilitar els botons
        DeletePersonalDataCandidat()
        btnAllCandidatures_Click(Nothing, Nothing)
    End Sub

    Protected Sub btnUserSelected_Click(sender As Object, e As EventArgs) Handles btnUserSelected.Click
        'Modificar l'estat de la candidature a 3 (seleccionat)
        candidatureActual = candidat.updateStateCandidature(lblCandidature.Text, 3)
        If MsgBox("Vol finalitzar l'oferta seleccionada? Al finalitzar-la, es descartaran totes les candidatures pendents", vbYesNo) Then
            'Modificar l'inactivation de la oferta a NOW
            job.updateDateJob(lblJobId.Text)
            'Descartar les candidatures pendents existents
            job.discardCandidatures(lblJobId.Text)
        End If
        'Buidar les dades personals e inhabilitar els botons
        DeletePersonalDataCandidat()
        btnAllCandidatures_Click(Nothing, Nothing)
    End Sub

    Protected Sub btnStudies_Click(sender As Object, e As EventArgs) Handles btnStudies.Click
        If grdStudies.Visible = True Then
            grdStudies.Visible = False
        Else
            grdStudies.Visible = True
        End If
    End Sub

    Protected Sub btnExperience_Click(sender As Object, e As EventArgs) Handles btnExperience.Click
        If grdExperience.Visible = True Then
            grdExperience.Visible = False
        Else
            grdExperience.Visible = True
        End If
    End Sub
    Protected Sub LoadGridStudies(usrActual As User)
        Dim user As New UserF
        Dim dr As SqlDataReader
        Dim fld As BoundField = Nothing

        dr = user.getAllStudies(usrActual.userId)
        ' Carrego les dades al gridview
        grdStudies.DataSource = dr
        grdStudies.DataBind()
    End Sub
    Protected Sub LoadGridExperience(usrActual As User)
        Dim user As New UserF
        Dim dr As SqlDataReader
        Dim fld As BoundField = Nothing

        dr = user.getAllExperience(usrActual.userId)
        ' Carrego les dades al gridview
        grdExperience.DataSource = dr
        grdExperience.DataBind()
    End Sub
    Private Sub grdStudies_RowDataBound(sender As Object, e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles grdStudies.RowDataBound
        If e.Row.RowType = DataControlRowType.DataRow Then
            ' Display the company name in italics.
            If e.Row.Cells(4).Text Then
                e.Row.Cells(4).Text = "Finalitzat"
            Else
                e.Row.Cells(4).Text = "En Curs"
            End If
        End If
    End Sub
    Protected Sub btnAddJob_Click(sender As Object, e As EventArgs) Handles btnAddJob.Click
        Response.Redirect("~/1.Jobs/SubPantalles/AddJob.aspx?idCompany=" & usrActual.CompanyId)
    End Sub

    Private Sub grdCertificates_RowCommand(sender As Object, e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles grdCertificates.RowCommand
        Dim docu As New DocumentF

        Select e.CommandName
            Case "Ver"
                Dim path As New ProcessStartInfo
                Dim loProces As New Process
                path.FileName = docu.getPath(System.Convert.ToInt32(e.CommandArgument))
                Try
                    loProces = Process.Start(path)
                Catch Exp As Exception
                    MsgBox("Error durant el proces", vbOK)
                End Try
        End Select

    End Sub


    Protected Sub btnCertificate_Click(sender As Object, e As EventArgs) Handles btnCertificate.Click
        If grdCertificates.Visible = True Then
            grdCertificates.Visible = False
        Else
            grdCertificates.Visible = True
        End If
    End Sub

    Protected Sub btnCurriculum_Click(sender As Object, e As EventArgs) Handles btnCurriculum.Click
        If grdCurriculums.Visible = True Then
            grdCurriculums.Visible = False
        Else
            grdCurriculums.Visible = True
        End If
    End Sub

    Protected Sub btnCartes_Click(sender As Object, e As EventArgs) Handles btnCartes.Click
        If grdCartesPresen.Visible = True Then
            grdCartesPresen.Visible = False
        Else
            grdCartesPresen.Visible = True
        End If
    End Sub

    Private Sub grdCurriculums_RowCommand(sender As Object, e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles grdCurriculums.RowCommand
        Dim docu As New DocumentF

        Select e.CommandName
            Case "Ver"
                Dim path As New ProcessStartInfo
                Dim loProces As New Process
                path.FileName = docu.getPath(System.Convert.ToInt32(e.CommandArgument))
                Try
                    loProces = Process.Start(path)
                Catch Exp As Exception
                    MsgBox("Error durant el proces", vbOK)
                End Try
        End Select

    End Sub

    Private Sub grdCartesPresen_RowCommand(sender As Object, e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles grdCartesPresen.RowCommand
        Dim docu As New DocumentF

        Select e.CommandName
            Case "Ver"
                Dim path As New ProcessStartInfo
                Dim loProces As New Process
                path.FileName = docu.getPath(System.Convert.ToInt32(e.CommandArgument))
                Try
                    loProces = Process.Start(path)
                Catch Exp As Exception
                    MsgBox("Error durant el proces", vbOK)
                End Try
        End Select
    End Sub
End Class