﻿Imports CercaFeina.business
Imports CercaFeina.common
Imports System.Data.SqlClient
Imports System.IO
Public Class PersonalSpace
    Inherits System.Web.UI.Page
    Dim usrActual As Company
    Dim usuariAct As User
    Dim documentE As New Document
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        usrActual = Session("usr")
        If IsNothing(usrActual) Then Response.Redirect("~/Blank.aspx")
        If Not IsPostBack Then
            LoadPersonalInformation(usrActual)
            LoadProvinces()
            LoadPhoto(usrActual)
        End If
    End Sub
    Protected Sub LoadPhoto(usrActual As Company)
        Dim docu As New DocumentF
        Dim path As New ProcessStartInfo
        Dim file As String


        path.FileName = docu.getPath(usrActual.Logo)
        If Not (path.FileName = "") Then
            file = path.FileName.Remove(0, 107)
            Photograph.ImageUrl = "~/4.Upload/" & usrActual.CompanyId & "/" & file
        End If
    End Sub
    Protected Sub LoadPersonalInformation(usrActual As Company)
        txtId.Text = usrActual.CompanyId
        txtName.Text = usrActual.CompanyName
        txtAddress.Text = usrActual.Address
        txtCity.Text = usrActual.City
        txtPostalCode.Text = usrActual.Postal_code
        txtTelephone.Text = usrActual.Phone
        txtEmail.Text = usrActual.Email
        txtweb.text = usrActual.Web
        txtContactName.text = usrActual.ContactName
        txtEmployees.Text = usrActual.Employees

        If usrActual.Ett = True Then
            rdYes.Checked = True
        Else
            rdNo.Checked = True
        End If
        txtAdditionalInformation.Text = usrActual.Description

    End Sub

    Protected Sub btnModify_Click(sender As Object, e As EventArgs) Handles btnModify.Click
        'Habilitar el botó de guardar i tots els objectes modicables.
        btnSave.Visible = True
        btnModify.Visible = False
        txtName.Enabled = True
        txtAddress.Enabled = True
        txtCity.Enabled = True
        txtPostalCode.Enabled = True
        txtTelephone.Enabled = True
        txtWeb.Enabled = True
        txtEmail.Enabled = True
        txtContactName.Enabled = True
        txtEmployees.Enabled = True
        cmbCity.Enabled = True
        cmbProvince.Enabled = True
        txtAdditionalInformation.Enabled = True
        rdYes.Enabled = True
        rdNo.Enabled = True
        FileUpload1.Visible = True
        btnAddPhoto.Visible = True
        lblMessage.Visible = True
    End Sub

    Protected Sub btnSave_Click(sender As Object, e As EventArgs) Handles btnSave.Click
        Dim usuari As New CompanyF
        Dim user As New UserF
        'verificar les dades introduides
        txtCity.Text = user.getProvinceIdByCity(cmbCity.Text.ToString)

        'Deshabilitar el botó de guardar i tots els objectes modicables.
        btnModify.Visible = True
        btnSave.Visible = False
        FileUpload1.Visible = False
        btnAddPhoto.Visible = False
        lblMessage.Visible = False

        txtName.Enabled = False
        txtAddress.Enabled = False
        txtCity.Enabled = False
        txtPostalCode.Enabled = False
        txtTelephone.Enabled = False
        txtWeb.Enabled = False
        txtEmail.Enabled = False
        txtContactName.Enabled = False
        txtEmployees.Enabled = False
        cmbCity.Enabled = False
        cmbProvince.Enabled = False
        txtAdditionalInformation.Enabled = False
        rdYes.Enabled = False
        rdNo.Enabled = False

        'Guardar els canvis
        usrActual.CompanyName = txtName.Text
        usrActual.Address = txtAddress.Text
        usrActual.City = txtCity.Text
        usrActual.Postal_code = txtPostalCode.Text
        If txtTelephone.Text = "" Then
            usrActual.Phone = 0
        Else
            usrActual.Phone = txtTelephone.Text
        End If
        usrActual.Email = txtEmail.Text
        usrActual.Web = txtWeb.Text
        usrActual.ContactName = txtContactName.Text
        If txtEmployees.Text = "" Then
            usrActual.Employees = 0
        Else
            usrActual.Employees = txtEmployees.Text
        End If
        usrActual.Description = txtAdditionalInformation.Text

        If rdYes.Checked Then
            usrActual.Ett = 1
        Else
            usrActual.Ett = 0
        End If
        'Guardar modificacions de les dades personals d'usuari
        usuari.update(usrActual)
    End Sub
     Protected Sub LoadProvinces()
        Dim usuari As New UserF
        Dim dr As SqlDataReader

        'Carregar la combo de ciutat segons la provincia seleccionada
        cmbProvince.Items.Clear()
        dr = usuari.getAllProvinces
        If dr.HasRows Then
            While dr.Read()
                cmbProvince.Items.Add(dr.Item(0))
            End While
            dr.Close()
        End If
        cmbProvince.Text = usrActual.Province
        'Carregar la combo de ciutat segons la provincia seleccionada
        cmbCity.Items.Clear()
        dr = usuari.getCitiesByProvince(cmbProvince.Text)
        If dr.HasRows Then
            While dr.Read()
                cmbCity.Items.Add(dr.Item(0))
            End While
            dr.Close()
        End If
        cmbCity.Text = usrActual.CityName
    End Sub
    Protected Sub cmbProvince_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cmbProvince.SelectedIndexChanged
        Dim usuari As New UserF
        Dim dr As SqlDataReader
        'Carregar la combo de ciutat segons la provincia seleccionada
        cmbCity.Items.Clear()
        dr = usuari.getCitiesByProvince(cmbProvince.Text)
        If dr.HasRows Then
            While dr.Read()
                cmbCity.Items.Add(dr.Item(0))
            End While
            dr.Close()
        End If
    End Sub

    Protected Sub btnAddPhoto_Click(sender As Object, e As EventArgs) Handles btnAddPhoto.Click
        lblMessage.Text = ""
        ' Before attempting to save the file, verify
        ' that the FileUpload control contains a file.
        If (FileUpload1.HasFile) Then
            ' Call a helper method routine to save the file.
            SaveFile(FileUpload1.PostedFile)
            LoadPhoto(usrActual)
        Else
            ' Notify the user that a file was not uploaded.
            lblMessage.Text = "No ha especificat cap document."
        End If
    End Sub


    Sub SaveFile(ByVal file As HttpPostedFile)
        Dim docu As New DocumentF
        Dim usuari As New CompanyF
        Dim path As String = ""

        'Verificar si existeix les carpetes
        If Not (Directory.Exists(Server.MapPath("~/4.Upload/" & usrActual.CompanyId & "/"))) Then
            Directory.CreateDirectory(Server.MapPath("~/4.Upload/" & usrActual.CompanyId & "/"))
        End If
        ' Specify the path to save the uploaded file to.
        Dim savePath As String = Server.MapPath("~/4.Upload/" & usrActual.CompanyId & "/")
        ' Get the name of the file to upload.
        Dim fileName As String = FileUpload1.FileName

        ' Append the name of the file to upload to the path.
        savePath += fileName

        ' Call the SaveAs method to save the uploaded
        ' file to the specified directory.
        FileUpload1.SaveAs(savePath)
        If (usrActual.Logo <> "") Then
            'Elimino el fitxer
            Path = docu.getPath(usrActual.Logo)
            Kill(Path)
            'Elimino la ruta de la base de dades
            docu.deleteDocument(usrActual.Logo)

        End If
        documentE.type = Document.enType.Photo
        documentE.UserId = usrActual.CompanyId
        documentE.Path = savePath
        documentE.Description = "LOGO"
        docu.insert(documentE)
        usrActual.Logo = docu.getPhotoById(usrActual.CompanyId)
        usuari.updatePhoto(usrActual)
        LoadPhoto(usrActual)

        ' Notify the user that the file was saved successfully.
        lblMessage.Text = "El teu document s'ha guardat correctament."
    End Sub
End Class
